#include <unistd.h>
#include <string.h>
#include <sys/stat.h>

#include "modules.h"
#define countof(a) (int)(sizeof(a) / sizeof(*(a)))

int change_brightness(FILE *fp, int val) {
    if(fputc(val, fp) == EOF) {
        fprintf(stderr, "fputs failed error: %m\n");
        return 1;
    }
    if(fseek(fp, 0, SEEK_SET) == -1) {
        fprintf(stderr, "fseek failed error: %m\n");
        return 1;
    }
    usleep(0.5*1000000);
    return 0;
}

int blink(void) {
    FILE *fp;
    int i;
    int check_w = 1;
    int result = 0;
    const char * const leds[] = {"app", "led1", "green"};
    char led[BUF_MAX];
    for(i = 0; i < countof(leds); i++) {
        sprintf(led, "/sys/class/leds/%s/brightness", leds[i]);
        check_w = access(led, W_OK);
        if (check_w != 0) {
            continue;
        }
        break;
    }

    if (check_w != 0) {
        fprintf(stderr, "Could not find led file\n");
        return 1;
    }

    fp = fopen(led, "w");
    if (fp == NULL) {
        fprintf(stderr, "fopen failed error: %m: %s\n", led);
        fclose(fp);
        return 1;
    }

    while(1) {
        if ((result = change_brightness(fp, '0')) != 0) {
            break;
        }
        if ((result = change_brightness(fp, '1')) != 0) {
            break;
        }
    }

    if(fclose(fp) != 0) {
        fprintf(stderr, "fclose failed error: log: %m\n");
        return 1;
    }

    if (result != 0) {
        return 1;
    }

    return 0;
}
